//: cadezdefs.h-- External FORTRAN definitions for subroutines and functons
//. in cadef.f and chicoord.f
#ifndef CADEZDEFS_H_
#define CADEZDEFS_H_

extern "FORTRAN" void cadef(const double &, const double &, const int &,
										const int &, double &, double &, double &,
										double &, double &);

extern "FORTRAN" void ichicord(const int &, const double [], const double &,
											const double &, const double &,
											const double &, const double &);

extern "FORTRAN" void cyl2chi(const double &, const double &, 
										double &, double &);

extern "FORTRAN" void diffeta1(const double &, const double &, 
											double &, double &);

extern "FORTRAN" void diffeta2(const double &, const double &, 
											double &, double &);

extern "FORTRAN" void diffeta3(const double &, const double &, 
											double &, double &);

extern "FORTRAN" double coefnorm();

extern "FORTRAN" int chi2cyl(const double &, const double &, 
										double &, double &, const double &, const int &);

extern "FORTRAN" void cylsing(double &, double &);

extern "FORTRAN" void chising(double &, double &);

#endif // CADEZDEFS_H_
