#include "math.h"
#include "lparx.h"
ifelse(NDIM,2,@
#include "cadez_hierarchy2.h"
#include "cadez_residuals2.h"
@,NDIM,3,@
#include "cadez_hierarchy3.h"
#include "cadez_residuals3.h"
@)

F_ID ID_Residual(cadez_discretization & lev,int UseTau)
{
	F_ID Resids;
	for_all_1(l,lev.Psi)
ifelse(NDIM,2,@
		psiresid(Resids.Psi,
					lev.Psi(l).data(),lev.PsiD(l).data(),
					lev.KK(l).data(),lev.PsiTau(l).data(),
					lev.PsiRes(l).data(),lev.LapX(l).data(),
					lev.LapY(l).data(),lev.Volume(l).data(),
					(int *)(lev.extents+l),(int *)(lev.interiors+l),
					(int *)(lev.fills+l),UseTau);
@,NDIM,3,@
		psiresid(Resids.Psi,
					lev.Psi(l).data(),lev.PsiD(l).data(),
					lev.KK(l).data(),lev.PsiTau(l).data(),
					lev.PsiRes(l).data(),lev.LapW(l).data(),
					lev.LapX(l).data(),lev.LapY(l).data(),lev.Volume(l).data(),
					(int *)(lev.extents+l),(int *)(lev.interiors+l),
					(int *)(lev.fills+l),UseTau);
@)
	end_for_all_no_sync
	mpReduceAdd(&Resids.Psi);
	Resids.Psi = sqrt(Resids.Psi);
	return Resids;
} // ID_Residual
