#include <stdio.h>
#include "math.h"
#include "lparx.h"
ifelse(NDIM,2,@
#include "cadez_hierarchy2.h"
#include "cadez_smoothers2.h"
@,NDIM,3,@
#include "cadez_hierarchy3.h"
#include "cadez_smoothers3.h"
@)

F_ID ID_Residual(cadez_discretization & , int);

F_ID ID_Smooth(cadez_discretization & lev,int N_smooths)
{
static TimeSection timer("Psi_Smooth()");
timer.enter_section();
	const int red = 0, black = 1;
	for(int loop = 0; loop < N_smooths; ++loop) {
		for_all_1(l,lev.Psi)
ifelse(NDIM,2,@
			psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
							lev.KK(l).data(), lev.PsiTau(l).data(),
							lev.LapX(l).data(),lev.LapY(l).data(),
							lev.Volume(l).data(),(int *)(lev.extents+l),
							(int *)(lev.interiors+l),(int *)(lev.fills+l),red);
			psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
							lev.KK(l).data(),lev.PsiTau(l).data(),
							lev.LapX(l).data(),lev.LapY(l).data(),
							lev.Volume(l).data(),(int *)(lev.extents+l),
							(int *)(lev.interiors+l),(int *)(lev.fills+l),black);
@,NDIM,3,@
			psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
							lev.KK(l).data(), lev.PsiTau(l).data(),
							lev.LapW(l).data(),lev.LapX(l).data(),
							lev.LapY(l).data(),lev.Volume(l).data(),
							(int *)(lev.extents+l),(int *)(lev.interiors+l),
							(int *)(lev.fills+l),red);
			psismoothrb(lev.Psi(l).data(),lev.PsiD(l).data(),
							lev.KK(l).data(),lev.PsiTau(l).data(),
							lev.LapW(l).data(),lev.LapX(l).data(),
							lev.LapY(l).data(),lev.Volume(l).data(),
							(int *)(lev.extents+l),(int *)(lev.interiors+l),
							(int *)(lev.fills+l),black);
@)
		end_for_all
		lev.fill_patch(lev.PsiD);
		lev.sync_fields();
	}
timer.exit_section();
	return ID_Residual(lev,1);
} // ID_Smooth
